#INCLUDE "SolWestWindEx.h"

*************************************************************
*: Author: Rick Strahl
*:         (c) West Wind Technologies, 2007
*:Contact: http://www.west-wind.com
*:Created: 07/01/2007
*************************************************************
DEFINE CLASS DotNetBridge AS Custom
	#IF .F.
		*:Help Documentation
		*:Topic:
		Class DotNetBridge

		*:Description:
		http://www.west-wind.com/webconnection/docs?page=_24n1cfw3a.htm (en)
		http://vfpdev.narod.ru/docs/xlstbl_r.html (rus)

		*:Example:

		*:Remarks:

		*:SeeAlso:


		*:ENDHELP
	#ENDIF

	*** Custom Properties

	*** Stock Properties
	oDotNetBridge = null

	cErrorMsg  = ""
	lError = .f.

	FUNCTION Init()
		this.Load()
	ENDFUNC


	************************************************************************
	*  CreateDotNetBridge
	****************************************
	***  Function: Creates an instance of the .NET Bridge component
	***            that allows loading of content.
	***    Assume: Define as LOCAL obridge as DOTNETBRIDG_CLASS
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION Load()

		IF VARTYPE(this.oDotNetBridge) != "O"
			*!*		DECLARE Integer ClrCreateInstance IN wwipstuff.dll string, string, string@, integer@
			*!*		lcError = SPACE(2048)
			*!*		lnSize = 0
			*!*		lnDispHandle = ClrCreateInstance("wwDotNetBridge","Westwind.WebConnection.wwDotNetBridge",@lcError,@lnSize)

			LOCAL lcError as String;
				,lnSize as Integer;
				,lnDispHandle as Integer;
				,lcOldPath as String;
				,lcSys16 as String;
				,lcProg as String; 
				,lnPos as Integer      
			lcOldPath = FULLPATH(CURDIR())
			lcProg = PROGRAM()
			lcSys16 = SYS(16)
			lnPos = ATC(lcProg, lcSys16)
			IF lnPos > 0 AND ATC('.', lcProg) > 0
				lcSys16 = TRIM(SUBSTRC(lcSys16, lnPos + LENC(lcProg)))
			ENDIF
			SET DEFAULT TO (LEFT(lcSys16, RAT("\", lcSys16)))
			DECLARE Integer ClrCreateInstanceFrom IN (FULLPATH(PATH_DLLS + CLRHOST_DLL)) string, string, string@, integer@
			lcError = SPACE(2048)
			lnSize = 0
			lnDispHandle = ClrCreateInstanceFrom(FULLPATH(PATH_DLLS + DOTNETBRIDG_DLL), DOTNETBRIDG_CLASS, @lcError, @lnSize)
			IF lnDispHandle < 1
				SET DEFAULT TO (lcOldPath)
				this.SetError(LEFT(lcError, lnSize))
				RETURN NULL
			ENDIF
			this.oDotNetBridge = SYS(3096, lnDispHandle)
			this.oDotNetBridge.LoadAssembly(ASSEMBLY_SYSTEM)
			SET DEFAULT TO (lcOldPath)
		ENDIF

		RETURN this.oDotNetBridge
	ENDFUNC
	*   CreateDotNetBridge

	************************************************************************
	*  Unload
	****************************************
	***  Function: Unloads the CLR and AppDomain
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION Unload()

		IF VARTYPE(this.oDotNetBridge) == "O"
			this.oDotNetBridge = NULL
			LOCAL lcOldPath as String;
				,lcSys16 as String;
				,lcProg as String; 
				,lnPos as Integer      
			lcOldPath = FULLPATH(CURDIR())
			lcProg = PROGRAM()
			lcSys16 = SYS(16)
			lnPos = ATC(lcProg, lcSys16)
			IF lnPos > 0 AND ATC('.', lcProg) > 0
				lcSys16 = TRIM(SUBSTRC(lcSys16, lnPos + LENC(lcProg)))
			ENDIF
			SET DEFAULT TO (LEFT(lcSys16, RAT("\", lcSys16)))
			DECLARE Integer ClrUnload IN (FULLPATH(PATH_DLLS + CLRHOST_DLL))
			SET DEFAULT TO (lcOldPath)
			ClrUnload()
		ENDIF

	ENDFUNC
	*   Unload

	*!*	************************************************************************
	*!*	*  UnloadDotNetBridge
	*!*	****************************************
	*!*	***  Function:
	*!*	***    Assume:
	*!*	***      Pass:
	*!*	***    Return:
	*!*	************************************************************************
	*!*	FUNCTION UnloadDotNetBridge()

	*!*	IF VARTYPE(this.oDotNetBridge) == "O"
	*!*		this.oDotNetBridge = NULL
	*!*		DECLARE Integer ClrUnload IN clrhost.dll
	*!*		ClrUnload()
	*!*	ENDIF

	*!*	ENDFUNC
	*!*	*   UnloadDotNetBridge

	************************************************************************
	*  CreateInstance
	****************************************
	***  Function: Creates an instance of a .NET class by full assembly
	***            name or local file name.
	***    Assume: Relies on clrhost.dll and wwDotNetBridge.dll
	***      Pass: lcLibrary - either one of these formats
	***                        System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
	***                        MyAssembly (where the assembly file is in the App's start path)***
	***            lcClass   - MyNamespace.MyClass
	***    Return: Instance or NULL
	************************************************************************
	FUNCTION CreateInstance(lcClass,lvParm1, lvParm2, lvParm3)
		LOCAL lnDispHandle, lnSize, loBridge, loObject, lnParmCount

		this.SetError()

		loBridge = this.Load()
		IF ISNULL(loBridge)
			RETURN NULL
		ENDIF

		lnParmCount = PCOUNT()
		DO CASE
			CASE lnParmCount = 2
				loObject = loBridge.CreateInstance_OneParm(lcClass,lvParm1)
			CASE lnParmCount = 3
				loObject = loBridge.CreateInstance_TwoParms(lcClass,lvParm1, lvParm2)
			CASE lnParmCount = 4
				loObject = loBridge.CreateInstance_TwoParms(lcClass,lvParm1, lvParm2, lvParm3)
			OTHERWISE
				loObject = loBridge.CreateInstance(lcClass)
		ENDCASE

		IF ISNULL(loObject) OR loBridge.Error
			this.SetError( loBridge.ErrorMessage )
			RETURN NULL
		ENDIF

		RETURN loObject
	ENDFUNC

	************************************************************************
	*  InvokeMethod
	****************************************
	***  Function: Invokes an instance method on an object
	***    Assume: Use when direct COM access doesn't work for things like collections/generics etc.
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION InvokeMethod(loObject, lcMethod, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
		LOCAL loBridge, lnParms, loResult

		this.SetError()

		loBridge = this.oDotNetBridge

		lnParms = PCOUNT()
		loResult = NULL
		DO CASE
			CASE lnParms = 3
				loResult = loBridge.InvokeMethod_OneParm(loObject, lcMethod, lvParm1)
			CASE lnParms = 4
				loResult = loBridge.InvokeMethod_TwoParms(loObject, lcMethod,lvParm1, lvParm2)
			CASE lnParms = 5
				loResult = loBridge.InvokeMethod_ThreeParms(loObject, lcMethod,lvParm1, lvParm2, lvParm3)
			CASE lnParms = 6
				loResult = loBridge.InvokeMethod_FourParms(loObject, lcMethod,lvParm1, lvParm2, lvParm3, lvParm4)
			CASE lnParms = 7
				loResult = loBridge.InvokeMethod_FiveParms(loObject, lcMethod,lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
			OTHERWISE
				loResult = loBridge.InvokeMethod(loObject, lcMethod)
		ENDCASE

		IF ISNULL(loResult) OR loBridge.Error
			this.cErrorMsg = loBridge.ErrorMessage
			this.lError = .T.
		ENDIF

		RETURN loResult
	ENDFUNC
	*   InvokeMethod

	************************************************************************
	*  GetProperty
	****************************************
	***  Function: Gets a property from a .NET object
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION GetProperty(loInstance,lcProperty)
		RETURN this.oDotNetBridge.GetProperty(loInstance, lcProperty)
	ENDFUNC
	*   GetProperty

	************************************************************************
	*  GetPropertyAsString
	****************************************
	***  Function: Gets a property from a .NET object
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION GetPropertyAsString(loInstance,lcProperty)
		RETURN this.oDotNetBridge.GetPropertyAsString(loInstance, lcProperty)
	ENDFUNC
	*   GetPropertyAsString

	************************************************************************
	*  SetProperty
	****************************************
	***  Function: Sets a property on a .NET object
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION SetProperty(loInstance, lcProperty, lvValue)
		this.oDotNetBridge.SetProperty(loInstance, lcProperty, lvValue)
	ENDFUNC
	*   SetProperty

	************************************************************************
	*  InvokeStaticMethod
	****************************************
	***  Function: Calls a static .NET method with up to 5 parameters
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION InvokeStaticMethod(lcTypeName, lcMethod, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
		LOCAL loBridge, lnParms, loResult

		this.SetError()

		loBridge = this.oDotNetBridge

		lnParms = PCOUNT()
		loResult = NULL
		DO CASE
			CASE lnParms = 3
				loResult = loBridge.InvokeStaticMethod_OneParm(lcTypeName, lcMethod, lvParm1)
			CASE lnParms = 4
				loResult = loBridge.InvokeStaticMethod_TwoParms(lcTypeName, lcMethod,lvParm1, lvParm2)
			CASE lnParms = 5
				loResult = loBridge.InvokeStaticMethod_ThreeParms(lcTypeName, lcMethod,lvParm1, lvParm2, lvParm3)
			CASE lnParms = 6
				loResult = loBridge.InvokeStaticMethod_FourParms(lcTypeName, lcMethod,lvParm1, lvParm2, lvParm3, lvParm4)
			CASE lnParms = 7
				loResult = loBridge.InvokeStaticMethod_FiveParms(lcTypeName, lcMethod,lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
			OTHERWISE
				loResult = loBridge.InvokeStaticMethod(lcTypeName, lcMethod)
		ENDCASE

		IF ISNULL(loResult) OR loBridge.Error
			this.cErrorMsg = loBridge.ErrorMessage
			this.lError = .T.
		ENDIF

		RETURN loResult
	ENDFUNC
	*   InvokeStaticMethod

	************************************************************************
	*  GetStaticProperty
	****************************************
	***  Function: Retrieves a static property value from a type
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION GetStaticProperty(lcType, lcProperty)
		LOCAL loBridge, lvResult

		loBridge = this.oDotNetBridge

		lvResult = loBridge.GetStaticProperty(lcType, lcProperty)

		IF loBridge.Error OR !EMPTY(loBridge.ErrorMessage)
			this.SetError(loBridge.ErrorMessage)
			RETURN NULL
		ENDIF

		RETURN lvResult
	ENDFUNC
	*   GetStaticProperty


	************************************************************************
	*  GetEnumValue
	****************************************
	***  Function: Retrieves an Enum value as a number from a string representation
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION GetEnumValue(lcType, lcProperty)
		RETURN this.GetStaticProperty(lcType, lcProperty)
	ENDFUNC
	*   GetEnumValue

	************************************************************************
	*  SetStaticProperty
	****************************************
	***  Function: Sets a static property value on a .NET type
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION SetStaticProperty(lcType,lcProperty,lcValue)
		LOCAL loBridge, lvResult

		loBridge = this.oDotNetBridge

		IF !loBridge.SetStaticProperty(lcType, lcProperty, lcValue)
			this.SetError(loBridge.ErrorMessage)
			RETURN .F.
		ENDIF

		RETURN .T.
	ENDFUNC
	*   SetStaticProperty

	************************************************************************
	*  LoadAssembly
	****************************************
	***  Function: Loads an assembly either by full assembly name or by
	***            fully qualified path.
	***    Assume:
	***      Pass: AssemblyName or full assembly file name
	***    Return: .T. or .F.
	************************************************************************
	FUNCTION LoadAssembly(lcAssembly)
		LOCAL loBridge

		this.SetError()

		loBridge = this.Load()

		IF ISNULL(loBridge)
			RETURN NULL
		ENDIF

		IF AT(":\",lcAssembly) > 0
			*** It's a file based assembly path
			IF !loBridge.LoadAssemblyFrom(lcAssembly)
				RETURN .F.
			ENDIF
		ELSE
			IF !loBridge.LoadAssembly(lcAssembly)
				RETURN .F.
			ENDIF
		ENDIF

		RETURN .T.
	ENDFUNC
	*   LoadClrAssembly

	*!*	************************************************************************
	*!*	*  CreateClrInstanceFrom
	*!*	****************************************
	*!*	***  Function: Creates an instance of a .NET class by referencing
	*!*	***            a fully qualified assembly path.
	*!*	***      Pass: lcLibrary - fully qualified path to the assembly
	*!*	***                        including extension
	*!*	***            lcClass   - MyNamespace.MyClass
	*!*	***    Return: Instance or NULL
	*!*	************************************************************************
	*!*	FUNCTION CreateClrInstance(lcLibrary,lcClass,lcError)
	*!*	LOCAL lnDispHandle, lnSize

	*!*	DECLARE Integer ClrCreateInstance IN ClrHost.dll string, string, string@, integer@

	*!*	lcError = SPACE(2048)
	*!*	lnSize = 0
	*!*	lnDispHandle = ClrCreateInstance("wcDotNetBridge","Westwind.WebConnection.wwDotNetBridge",@lcError,@lnSize)

	*!*	IF lnDispHandle < 1
	*!*	   lcError = LEFT(lcError,lnSize)
	*!*	   RETURN NULL
	*!*	ENDIF

	*!*	RETURN SYS(3096, lnDispHandle)
	*!*	ENDFUNC


	************************************************************************
	*  SetError
	****************************************
	***  Function:
	***    Assume:
	***      Pass:
	***    Return:
	************************************************************************
	FUNCTION SetError(lcMessage)

		IF EMPTY(lcMessage)
			this.lError = .f.
			this.cErrorMsg = ""
			RETURN
		ENDIF

		this.lError = .t.
		this.cErrorMsg = lcMessage

	ENDFUNC
	*   SetError
	

	************************************************************************
	*  GetConstructor
	****************************************
	***  Function: Creates ConstrucrorInfo object by .NET class 
	***            and the list of .NET types of arguments (as string type)
	***    Assume:
	***      Pass:
	***    Return: ConstrucrorInfo object or NULL
	************************************************************************
	FUNCTION GetConstructor(lcClass, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)

		LOCAL loBridge, lnParms, loResult

		this.SetError()

		loBridge = this.Load()
		IF ISNULL(loBridge)
			RETURN NULL
		ENDIF

		lnParms = PCOUNT()
		loResult = NULL
		DO CASE
			CASE lnParms = 2
				loResult = loBridge.GetConstructorInfo_OneParm(lcClass, lvParm1)
			CASE lnParms = 3
				loResult = loBridge.GetConstructorInfo_TwoParms(lcClass, lvParm1, lvParm2)
			CASE lnParms = 4
				loResult = loBridge.GetConstructorInfo_ThreeParms(lcClass, lvParm1, lvParm2, lvParm3)
			CASE lnParms = 5
				loResult = loBridge.GetConstructorInfo_FourParms(lcClass, lvParm1, lvParm2, lvParm3, lvParm4)
			CASE lnParms = 6
				loResult = loBridge.GetConstructorInfo_FiveParms(lcClass, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
			OTHERWISE
				loResult = loBridge.GetConstructorInfo(lcClass)
		ENDCASE

		IF ISNULL(loResult) OR loBridge.Error
			this.cErrorMsg = loBridge.ErrorMessage
			this.lError = .T.
		ENDIF

		RETURN loResult
	ENDFUNC
	*  GetConstructor
	

	************************************************************************
	*  CreateInstanceObject
	****************************************
	***  Function: Creates instance object by ConstructorInfo object (see GetConstructor())
	***            and the list value of arguments
	***    Assume:
	***      Pass:
	***    Return: Instance of created object or NULL
	************************************************************************
	FUNCTION CreateInstanceObject(loConstructor, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
		LOCAL loBridge, lnParms, loResult

		this.SetError()

		loBridge = this.oDotNetBridge

		lnParms = PCOUNT()
		loResult = NULL
		DO CASE
			CASE lnParms = 2
				loResult = loBridge.CreateInstance_ConstructorInfo_OneParm(loConstructor, lvParm1)
			CASE lnParms = 3
				loResult = loBridge.CreateInstance_ConstructorInfo_TwoParms(loConstructor, lvParm1, lvParm2)
			CASE lnParms = 4
				loResult = loBridge.CreateInstance_ConstructorInfo_ThreeParms(loConstructor, lvParm1, lvParm2, lvParm3)
			CASE lnParms = 5
				loResult = loBridge.CreateInstance_ConstructorInfo_FourParms(loConstructor, lvParm1, lvParm2, lvParm3, lvParm4)
			CASE lnParms = 6
				loResult = loBridge.CreateInstance_ConstructorInfo_FiveParms(loConstructor, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
			OTHERWISE
				loResult = loBridge.CreateInstance_ConstructorInfo(loConstructor)
		ENDCASE

		IF ISNULL(loResult) OR loBridge.Error
			this.cErrorMsg = loBridge.ErrorMessage
			this.lError = .T.
		ENDIF

		RETURN loResult
	ENDFUNC
	*  CreateInstanceObject

	************************************************************************
	*  GetMethod
	****************************************
	***  Function: Gets MethodInfo object by .NET class object, MethodName
	***            and the list of .NET types of arguments (as string type)
	***    Assume:
	***      Pass:
	***    Return: MethodInfo object or NULL
	************************************************************************
	FUNCTION GetMethod(loClass, lcMethod, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)

		LOCAL loBridge, lnParms, loResult

		this.SetError()

		loBridge = this.Load()
		IF ISNULL(loBridge)
			RETURN NULL
		ENDIF

		lnParms = PCOUNT()
		loResult = NULL
		DO CASE
			CASE lnParms = 3
				loResult = loBridge.GetMethodInfo_OneParm(loClass, lcMethod, lvParm1)
			CASE lnParms = 4
				loResult = loBridge.GetMethodInfo_TwoParms(loClass, lcMethod, lvParm1, lvParm2)
			CASE lnParms = 5
				loResult = loBridge.GetMethodInfo_ThreeParms(loClass, lcMethod, lvParm1, lvParm2, lvParm3)
			CASE lnParms = 6
				loResult = loBridge.GetMethodInfo_FourParms(loClass, lcMethod, lvParm1, lvParm2, lvParm3, lvParm4)
			CASE lnParms = 7
				loResult = loBridge.GetMethodInfo_FiveParms(loClass, lcMethod, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
			OTHERWISE
				loResult = loBridge.GetMethodInfo(loClass, lcMethod)
		ENDCASE

		IF ISNULL(loResult) OR loBridge.Error
			this.cErrorMsg = loBridge.ErrorMessage
			this.lError = .T.
		ENDIF

		RETURN loResult
	ENDFUNC
	*  GetConstructor
	

	************************************************************************
	*  InvokeMethodObject
	****************************************
	***  Function: Invoke method by .NET Class object,
	***            MethodInfo object (see GetMethod()) and objects of args
	***    Assume:
	***      Pass:
	***    Return: Instance of created object or NULL
	************************************************************************
	FUNCTION InvokeMethodObject(loClass, loMethod, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
		LOCAL loBridge, lnParms, loResult

		this.SetError()

		loBridge = this.oDotNetBridge

		lnParms = PCOUNT()
		loResult = NULL
		DO CASE
			CASE lnParms = 3
				loResult = loBridge.InvokeMethod_MethodInfo_OneParm(loClass, loMethod, lvParm1)
			CASE lnParms = 4
				loResult = loBridge.InvokeMethod_MethodInfo_TwoParms(loClass, loMethod, lvParm1, lvParm2)
			CASE lnParms = 5
				loResult = loBridge.InvokeMethod_MethodInfo_ThreeParms(loClass, loMethod, lvParm1, lvParm2, lvParm3)
			CASE lnParms = 6
				loResult = loBridge.InvokeMethod_MethodInfo_FourParms(loClass, loMethod, lvParm1, lvParm2, lvParm3, lvParm4)
			CASE lnParms = 7
				loResult = loBridge.InvokeMethod_MethodInfo_FiveParms(loClass, loMethod, lvParm1, lvParm2, lvParm3, lvParm4, lvParm5)
			OTHERWISE
				loResult = loBridge.InvokeMethod_MethodInfo(loClass, loMethod)
		ENDCASE

		IF ISNULL(loResult) OR loBridge.Error
			this.cErrorMsg = loBridge.ErrorMessage
			this.lError = .T.
		ENDIF

		RETURN loResult
	ENDFUNC
	*  CreateInstanceObject

ENDDEFINE
*EOC wwDotNetBridge



