#INCLUDE "SolWestWindEx.h"
#INCLUDE "FrameworkWrap.h"

*////////////////////////////////////////////////////////
*// baseFwWrap - base for any wrap to MS Framework class
DEFINE CLASS baseFwWrap as Session
	oFwObj = NULL
	cClassName = ""
	PROCEDURE Init
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object"
		ENDIF
		IF !this.IsClassObject()
			ERROR "Not define "+ this.Name + ".cClassName property"  
		ENDIF
	ENDPROC
	PROCEDURE IsBridgeObject
		RETURN (TYPE('poBridge') = 'O' AND !ISNULL(poBridge))
	ENDPROC
	PROCEDURE IsClassObject
		RETURN !EMPTY(this.cClassName)
	ENDPROC
	PROCEDURE IsFrameworkObject
		RETURN (VARTYPE(this.oFwObj) = 'O')
	ENDPROC
	PROCEDURE ToString 
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.toString()'
		ENDIF
		LOCAL lcRetVal as String
		lcRetVal = poBridge.InvokeMethod(this.oFwObj, 'ToString')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.ToString()')
		ENDIF
		RETURN lcRetVal
	ENDPROC
	PROCEDURE GetOwnerFwObject
		RETURN this.oFwObj
	ENDPROC
	PROCEDURE Destroy
		this.oFwObj = NULL
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*////////////////////////////////////////////////////////////////
*// RegistryKey - wrap to Microsoft.Win32.RegistryKey
DEFINE CLASS RegistryKey as baseFwWrap
	cClassName = "Microsoft.Win32.RegistryKey"
	PROCEDURE Init
		LPARAMETERS toRegistryKey
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = toRegistryKey
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE OpenSubKey
		LPARAMETERS tcKeyName
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.OpenSubKey()'
		ENDIF
		LOCAL loRetVal as Object
		loRetVal = poBridge.InvokeMethod(this.oFwObj, 'OpenSubKey', tcKeyName)
		IF VARTYPE(loRetVal) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.OpenSubKey()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE GetValue
		LPARAMETERS tcName
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetValue()'
		ENDIF
		LOCAL luRetVal
		luRetVal = poBridge.InvokeMethod(this.oFwObj, 'GetValue', tcName)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetValue()')
		ENDIF
		RETURN luRetVal
	ENDPROC
	PROCEDURE Close
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Close()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Close()')
		ENDIF
	ENDPROC
	PROCEDURE Destroy
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Destroy()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// Uri - wrap to System.Uri
DEFINE CLASS Uri as baseFwWrap
	cClassName = "System.Uri"
	PROCEDURE Init
		LPARAMETERS tuUrl, tuArg2, tuArg3
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		LOCAL lnCntArgs as Integer
		lnCntArgs = PCOUNT()
		DO CASE
		CASE lnCntArgs = 1
			this.oFwObj = poBridge.CreateInstance(this.oConstr,  tuUrl)
		CASE lnCntArgs = 2
			LOCAL lcTypeArg1 as String;
				,lcTypeArg2 as String;
				,loConstr as Object 
			lcTypeArg1 = VARTYPE(tuUrl)
			lcTypeArg2 = VARTYPE(tuArg2)
			DO CASE
			CASE lcTypeArg1 = 'C' AND lcTypeArg2 = 'L'
				loConstr = poBridge.GetConstructor(this.cClassName, "System.String", "System.Boolean")
			CASE lcTypeArg1 = 'C' AND lcTypeArg2 = 'N'	
				loConstr = poBridge.GetConstructor(this.cClassName, "System.String", "System.UriKind")
			CASE lcTypeArg1 = 'O' AND lcTypeArg2 = 'C'	
				loConstr = poBridge.GetConstructor(this.cClassName, "System.Uri", "System.String")
			CASE lcTypeArg1 = 'O' AND lcTypeArg2 = 'O'	
				loConstr = poBridge.GetConstructor(this.cClassName, "System.Uri", "System.Uri")
			OTHERWISE	
				ERROR ("Error type of args. In " + this.Name + '.Init()')
			ENDCASE
			IF VARTYPE(loConstr) # 'O'
				ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
			ENDIF
			this.oFwObj = poBridge.CreateInstanceObject(loConstr,  tuUrl, tuArg2)
		CASE lnCntArgs = 3
			LOCAL lcTypeArg1 as String;
				,lcTypeArg2 as String;
				,lcTypeArg3 as String
			lcTypeArg1 = VARTYPE(tuUrl)
			lcTypeArg2 = VARTYPE(tuArg2)
			lcTypeArg3 = VARTYPE(tuArg3)
			IF lcTypeArg1 = 'O' AND lcTypeArg2 = 'C' AND lcTypeArg3 = 'L'
				LOCAL loConstr as Object 
				loConstr = poBridge.GetConstructor(this.cClassName, "System.Uri", "System.String", "System.Boolean")
				IF VARTYPE(loConstr) # 'O'
					ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
				ENDIF
				this.oFwObj = poBridge.CreateInstanceObject(loConstr,  tuUrl, tuArg2, tuArg3)
			ELSE	
				ERROR ("Error type of args. In " + this.Name + '.Init()')
			ENDIF
		ENDCASE
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE Destroy
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// Package - wrap to System.IO.Stream
DEFINE CLASS Stream as baseFwWrap
	cClassName = "System.IO.Stream"
	Position = 0
	*oMethodSeek = NULL
	PROCEDURE Init
		LPARAMETERS toStream
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = toStream
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE Position_ASSIGN
		LPARAMETERS tnPosition
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Flush()'
		ENDIF
		poBridge.SetProperty(this.oFwObj, 'Position', tnPosition)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Position_ASSIGN()')
		ENDIF	
	ENDPROC
	PROCEDURE Position_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Flush()'
		ENDIF
		LOCAL lcPosition as String 
		lcPosition = poBridge.GetPropertyAsString(this.oFwObj, 'Position')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Position_ACCESS()')
		ENDIF
		this.Position = INT(VAL(lcPosition))
		RETURN this.Position	
	ENDPROC
	
*!*		PROCEDURE Seek
*!*			LPARAMETERS tnOffset, tnSeekOrigin
*!*			IF !this.IsBridgeObject()
*!*				ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
*!*					+ " in " + this.Name + '.Seek()'
*!*			ENDIF
*!*			IF VARTYPE(this.oMethodSeek) # 'O'
*!*				LOCAL lcSo as String 
*!*				lcSo = poBridge.InvokeMethod(this.oFwObj, 'ToString')
*!*				this.oMethodSeek = poBridge.GetMethod(this.oFwObj, 'Seek', 'System.UInt64', 'System.IO.SeekOrigin')
*!*				IF VARTYPE(this.oMethodSeek) # 'O'
*!*					ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Seek()')
*!*				ENDIF
*!*			ENDIF
*!*			poBridge.InvokeMethodObject(this.oFwObj, this.oMethodSeek, tnOffset, tnSeekOrigin)
*!*			IF !EMPTY(poBridge.cErrorMsg)
*!*				ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Seek()')
*!*			ENDIF
*!*		ENDPROC
	PROCEDURE Flush
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Flush()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Flush')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Flush()')
		ENDIF
	ENDPROC
	PROCEDURE Close
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Close()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Close()')
		ENDIF
	ENDPROC
	PROCEDURE Destroy
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Destroy()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		*this.oMethodSeek = NULL
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// MemoryStream - wrap to System.IO.MemoryStream
DEFINE CLASS MemoryStream as baseFwWrap
	cClassName = "System.IO.MemoryStream"
	Length = 0
	PROCEDURE Init
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.CreateInstance(this.cClassName)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE GetBuffer
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetBuffer()'
		ENDIF
		LOCAL lcRetVal as String 
		lcRetVal = poBridge.InvokeMethod(this.oFwObj, 'GetBuffer')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetBuffer()')
		ENDIF
		RETURN lcRetVal
	ENDPROC
	PROCEDURE Length_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetBuffer()'
		ENDIF
		LOCAL lcLength as String 
		lcLength = poBridge.GetPropertyAsString(this.oFwObj, "Length")
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetBuffer()')
		ENDIF
		this.Length = INT(VAL(lcLength))
		RETURN this.Length
	ENDPROC
	PROCEDURE Flush
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Flush()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Flush')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Flush()')
		ENDIF
	ENDPROC
	PROCEDURE Close
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Close()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Close()')
		ENDIF
	ENDPROC
	PROCEDURE Destroy
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Destroy()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// Encoding - wrap to System.Text.Encoding
DEFINE CLASS Encoding as baseFwWrap
	cClassName = "System.Text.Encoding"
	PROCEDURE Init
		LPARAMETERS tuEncoding
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.InvokeStaticMethod(this.cClassName, "GetEncoding", tuEncoding)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE GetString
		LPARAMETERS tcbytes as String, tnIndex as Integer, tnCount as Integer 
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetString()'
		ENDIF
		LOCAL lcRetVal as String 
		lcRetVal = poBridge.InvokeMethod(this.oFwObj, 'GetString', tcbytes, tnIndex, tnCount)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetString()')
		ENDIF
		RETURN lcRetVal
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*////////////////////////////////////////////////////////////////
*// XmlNamespaceManager - wrap to System.Xml.XmlNamespaceManager
DEFINE CLASS XmlNamespaceManager as baseFwWrap
	cClassName = "System.Xml.XmlNamespaceManager"
	PROCEDURE Init
		LPARAMETERS toNameTable
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.CreateInstance(this.cClassName, toNameTable)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE AddNamespace
		LPARAMETERS tcPrefix, tcUri
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.AddNamespace()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'AddNamespace', tcPrefix, tcUri)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.AddNamespace()')
		ENDIF
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// XmlDocument - wrap to System.Xml.XmlDocument
DEFINE CLASS XmlDocument as baseFwWrap
	cClassName = "System.Xml.XmlDocument"
	DocumentElement = NULL
	NameTable = NULL
	PROCEDURE Init
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.CreateInstance(this.cClassName)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE Load
		LPARAMETERS tuParam
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Load()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Load', tuParam)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Load()')
		ENDIF
	ENDPROC
	PROCEDURE LoadXml
		LPARAMETERS tcXml
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.LoadXml()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'LoadXml', tcXml)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.LoadXml()')
		ENDIF
	ENDPROC
	PROCEDURE CreateNavigator
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.CreateNavigator()'
		ENDIF
		LOCAL loRetVal as Object 
		loRetVal = poBridge.InvokeMethod(this.oFwObj, 'CreateNavigator')
		IF VARTYPE(loRetVal) != 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.CreateNavigator()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE Save
		LPARAMETERS tuParam
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Save()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Save', tuParam)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Save()')
		ENDIF
	ENDPROC
	PROCEDURE DocumentElement_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.DocumentElement_ACCESS()'
		ENDIF
		this.DocumentElement = poBridge.GetProperty(this.oFwObj, "DocumentElement")
		IF VARTYPE(this.DocumentElement) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.DocumentElement_ACCESS()')
		ENDIF
		RETURN this.DocumentElement
	ENDPROC
	PROCEDURE NameTable_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.NameTable_ACCESS()'
		ENDIF
		this.NameTable = poBridge.GetProperty(this.oFwObj, "NameTable")
		IF VARTYPE(this.NameTable) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.NameTable_ACCESS()')
		ENDIF
		RETURN this.NameTable
	ENDPROC
	PROCEDURE Destroy
		this.NameTable = NULL
		this.DocumentElement = NULL
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*////////////////////////////////////////////////////////////////
*// XmlNode - wrap to System.Xml.XmlNode
DEFINE CLASS XmlNode as baseFwWrap
	cClassName = "System.Xml.XmlNode"
	Value = ""
	PROCEDURE Init
		LPARAMETERS toXmlNode
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = toXmlNode
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE SelectSingleNode
		LPARAMETERS tcXpath, toNsMngr
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.SelectSingleNode()'
		ENDIF
		LOCAL lnCntArgs as Integer
		lnCntArgs = PCOUNT()
		LOCAL loRetVal as Object
		DO CASE
		CASE lnCntArgs = 1
			loRetVal = poBridge.InvokeMethod(this.oFwObj, 'SelectSingleNode', tcXpath)
		CASE lnCntArgs = 2
			loRetVal = poBridge.InvokeMethod(this.oFwObj, 'SelectSingleNode', tcXpath, toNsMngr)
		OTHERWISE
			ERROR ("Error types of agrs" + " In " + this.Name + '.SelectSingleNode()')
		ENDCASE
		IF VARTYPE(loRetVal) != 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.SelectSingleNode()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE Value_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Value_ACCESS()'
		ENDIF
		this.Value = poBridge.GetProperty(this.oFwObj, "Value")
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Value_ACCESS()')
		ENDIF	
		RETURN this.Value
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// XmlElement - wrap to System.Xml.XmlElement
DEFINE CLASS XmlElement as baseFwWrap
	cClassName = "System.Xml.XmlElement"
	InnerText = ""
	ElementName = ""
	PROCEDURE Init
		LPARAMETERS toXmlElement
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = toXmlElement
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE CreateNavigator
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.CreateNavigator()'
		ENDIF
		LOCAL loRetVal as Object 
		loRetVal = poBridge.InvokeMethod(this.oFwObj, 'CreateNavigator')
		IF VARTYPE(loRetVal) != 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.CreateNavigator()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE GetNamespaceOfPrefix
		LPARAMETERS tcPrefix
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetNamespaceOfPrefix()'
		ENDIF
		LOCAL lcRetVal as String 
		lcRetVal = poBridge.InvokeMethod(this.oFwObj, 'GetNamespaceOfPrefix', tcPrefix)
		IF VARTYPE(lcRetVal) != 'C' OR !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetNamespaceOfPrefix()')
		ENDIF
		RETURN lcRetVal
	ENDPROC
	PROCEDURE SelectSingleNode
		LPARAMETERS tcXpath, toNsMngr
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.SelectSingleNode()'
		ENDIF
		LOCAL lnCntArgs as Integer
		lnCntArgs = PCOUNT()
		LOCAL loRetVal as Object
		DO CASE
		CASE lnCntArgs = 1
			loRetVal = poBridge.InvokeMethod(this.oFwObj, 'SelectSingleNode', tcXpath)
		CASE lnCntArgs = 2
			loRetVal = poBridge.InvokeMethod(this.oFwObj, 'SelectSingleNode', tcXpath, toNsMngr)
		OTHERWISE
			ERROR ("Error types of agrs" + " In " + this.Name + '.SelectSingleNode()')
		ENDCASE
		IF VARTYPE(loRetVal) != 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.SelectSingleNode()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE InnerText_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.InnerText_ACCESS()'
		ENDIF
		this.InnerText = poBridge.GetProperty(this.oFwObj, "InnerText")
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.InnerText_ACCESS()')
		ENDIF	
		RETURN this.InnerText
	ENDPROC
	PROCEDURE ElementName_ACCESS
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.ElementName_ACCESS()'
		ENDIF
		this.ElementName = poBridge.GetProperty(this.oFwObj, "Name")
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.ElementName_ACCESS()')
		ENDIF
		RETURN this.ElementName
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*////////////////////////////////////////////////////////////////////////
*// XmlTextWriter - wrap to System.Xml.XmlTextWriter
DEFINE CLASS XmlTextWriter as baseFwWrap
	cClassName = "System.Xml.XmlTextWriter"
	PROCEDURE Init
		LPARAMETERS tuArg1, tuArg2
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		LOCAL lnCntArgs as Integer 
		lnCntArgs = PCOUNT()
		DO CASE
		CASE lnCntArgs = 1
			this.oFwObj = poBridge.CreateInstance(this.cClassName, tuArg1)
		CASE lnCntArgs = 2
			LOCAL loConstr as Object, lcArg1Type as String
			lcArg1Type = tuArg1.ToString() 
			loConstr = poBridge.GetConstructor(this.cClassName, lcArg1Type, "System.Text.Encoding")
			IF VARTYPE(loConstr) # 'O'
				ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
			ENDIF
			this.oFwObj = poBridge.CreateInstanceObject(loConstr, tuArg1, tuArg2)
		OTHERWISE	
			ERROR ("Error number of args." + " In " + this.Name + '.Init()')
		ENDCASE	
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE Flush
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Flush()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Flush')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Flush()')
		ENDIF
	ENDPROC
	PROCEDURE Close
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Close()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Close()')
		ENDIF
	ENDPROC
	PROCEDURE Destroy
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Destroy()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*///////////////////////////////////////////////////////////////
*// XsltArgumentList - wrap to System.Xml.Xsl.XsltArgumentList
DEFINE CLASS XsltArgumentList as baseFwWrap
	cClassName = "System.Xml.Xsl.XsltArgumentList"
	PROCEDURE Init
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.CreateInstance(this.cClassName)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE AddParam
		LPARAMETERS tcParamName, tcNamespaceUri, toParamValue
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.AddParam()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'AddParam', tcParamName, tcNamespaceUri, toParamValue)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.AddParam()')
		ENDIF
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*////////////////////////////////////////////////////////////////////////
*// XslCompiledTransform - wrap to System.Xml.Xsl.XslCompiledTransform
DEFINE CLASS XslCompiledTransform as baseFwWrap
	cClassName = "System.Xml.Xsl.XslCompiledTransform"
	PROCEDURE Init
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.CreateInstance(this.cClassName)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE Load
		LPARAMETERS toStylesheetUri
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Load()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Load', toStylesheetUri)
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Load()')
		ENDIF
	ENDPROC
	PROCEDURE Transform
		LPARAMETERS toInput, toArg1, toArg2
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Transform()'
		ENDIF
		LOCAL lnCntPrms
		lnCntPrms = PCOUNT()
		DO CASE
		CASE lnCntPrms = 3
			poBridge.InvokeMethod(this.oFwObj, 'Transform', toInput, toArg1, toArg2)
		CASE lnCntPrms = 2
			poBridge.InvokeMethod(this.oFwObj, 'Transform', toInput, toArg1)
		OTHERWISE	
			ERROR ("Error number of args." + " In " + this.Name + '.Transform()')
		ENDCASE	
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Transform()')
		ENDIF
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// Package - wrap to System.IO.Packaging.Package
DEFINE CLASS Package as baseFwWrap
	cClassName = "System.IO.Packaging.Package"
	PROCEDURE Init
		LPARAMETERS tcFileName 
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = poBridge.InvokeStaticMethod(this.cClassName, "Open", tcFileName)
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE GetPart
		LPARAMETERS toUri
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetPart()'
		ENDIF
		LOCAL loRetVal as Object 
		loRetVal = poBridge.InvokeMethod(this.oFwObj, 'GetPart', toUri)
		IF VARTYPE(loRetVal) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetPart()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE Flush
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Flush()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Flush')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Flush()')
		ENDIF
	ENDPROC
	PROCEDURE Close
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Close()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		IF !EMPTY(poBridge.cErrorMsg)
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Close()')
		ENDIF
	ENDPROC
	PROCEDURE Destroy
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.Destroy()'
		ENDIF
		poBridge.InvokeMethod(this.oFwObj, 'Close')
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE

*/////////////////////////////////////////////////////
*// Package - wrap to System.IO.Packaging.PackagePart
DEFINE CLASS PackagePart as baseFwWrap
	cClassName = "System.IO.Packaging.PackagePart"
	oMethodGetStream2 = NULL
	PROCEDURE Init
		LPARAMETERS toPackagePart
		IF !DODEFAULT()
			RETURN .F.
		ENDIF
		this.oFwObj = toPackagePart
		IF VARTYPE(this.oFwObj) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.Init()')
		ENDIF
	ENDPROC
	PROCEDURE GetStream
		LPARAMETERS tnFileMode, tnFileAccess
		IF !this.IsBridgeObject()
			ERROR "Not found instance of " + BRIDGE_CLASS + " object" ;
				+ " in " + this.Name + '.GetStream()'
		ENDIF
		LOCAL loRetVal as Object;
			,lnCntArgs as Integer 
		lnCntArgs = PCOUNT()
		DO CASE
		CASE lnCntArgs = 0
			loRetVal = poBridge.InvokeMethod(this.oFwObj, "GetStream")
		CASE lnCntArgs = 1
			loRetVal = poBridge.InvokeMethod(this.oFwObj, "GetStream", tnFileMode)
		CASE lnCntArgs = 2
			IF VARTYPE(this.oMethodGetStream2) # 'O'
				this.oMethodGetStream2 = poBridge.GetMethod(this.oFwObj, "GetStream";
					,"System.IO.FileMode", "System.IO.FileAccess")
				IF VARTYPE(this.oMethodGetStream2) # 'O'
					ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetStream()')
				ENDIF
			ENDIF
			loRetVal = poBridge.InvokeMethodObject(this.oFwObj, this.oMethodGetStream2;
				,tnFileMode, tnFileAccess)
		OTHERWISE	
			ERROR ("Error number of args." + " In " + this.Name + '.Init()')
		ENDCASE	

		IF VARTYPE(loRetVal) # 'O'
			ERROR (poBridge.cErrorMsg + " In " + this.Name + '.GetStream()')
		ENDIF
		RETURN loRetVal
	ENDPROC
	PROCEDURE Destroy
		this.oMethodGetStream2 = NULL
		DODEFAULT()
	ENDPROC
	*// Insert your code here for implement any other PEMs for this class...
ENDDEFINE