#DEFINE XML_FILE	"employee"
#DEFINE SUBDIR_XML	"XML"
#DEFINE XPATH_CT	"//xsd:complexType"

LPARAMETERS tcFileName
LOCAL lcFileName as String
lcFileName = XML_FILE 
IF PCOUNT() > 0 AND VARTYPE(tcFileName) = 'C' AND !EMPTY(tcFileName)
	lcFileName = tcFileName
ENDIF

LOCAL lcSys16 as String;
	,lcCurPath as String;
	,lcXmlPath as String
lcSys16 = SYS(16)
lcCurPath = LOWER(LEFT(lcSys16, RATC("\", lcSys16)))
lcXmlPath = ADDBS(LOWER(LEFT(lcSys16, RATC("\", lcSys16, 2)) + SUBDIR_XML))
SET DEFAULT TO (lcCurPath)

LOCAL lcFileXsd as String
lcFileXsd = FORCEEXT(lcXmlPath + lcFileName, "xsd")
IF !FILE(lcFileXsd)
	ERROR 101, lcFileXsd
ENDIF

LOCAL loEx as Exception;
	,loXA as XMLAdapter;
	,loXmlDoc as MSXML2.DOMDocument;  
	,loRoot as MSXML2.IXMLDOMElement;
	,loNodesCT as MSXML2.IXMLDOMNodeList;
	,loXnCT as MSXML2.IXMLDOMNode;
	,loAttrMixed As MSXML2.IXMLDOMAttribute 
TRY 
	loXA = CREATEOBJECT("XMLAdapter")
	loXA.LoadXML(lcFileXsd,.T.,.F.)
	loRoot = loXA.IXMLDOMElement
	loXmlDoc = loRoot.ownerDocument 
	loNodesCT = loRoot.selectNodes(XPATH_CT)
	IF VARTYPE(loNodesCT) # 'O' OR loNodesCT.length = 0
		ERROR "Not found elements: " + XPATH_CT
	ENDIF
	LOCAL lnItem as Integer, lnCntAdd as Integer
	lnCntAdd = 0 
	FOR lnItem = 0 TO loNodesCT.length - 1
		loXnCT = loNodesCT.item(lnItem)
		IF loXnCT.attributes.length = 0
			loAttrMixed = loXmlDoc.createAttribute("mixed")
			loAttrMixed.value = "true"  
			loXnCT.attributes.setNamedItem(loAttrMixed)
			IF loXnCT.attributes.length > 0
				lnCntAdd = lnCntAdd + 1
			ELSE	
				ERROR "Can not create attribute mixed for item: " + TRANSFORM(lnItem)
			ENDIF	 
		ENDIF  
	ENDFOR
	IF lnCntAdd > 0
		loXmlDoc.save(lcFileXsd)
		?"Add " + TRANSFORM(lnCntAdd) + " mixed attributes into file: '" + lcFileXsd + "'"
	ENDIF
CATCH TO loEx
	? "Error: " + TRANSFORM(loEx.ErrorNo) 
	? "Message: " + loEx.Message 
FINALLY
	loAttrMixed = NULL
	loXnCT = NULL
	loNodesCT = NULL
	loRoot = NULL
	loXmlDoc = NULL
	loXA = NULL
ENDTRY