CLEAR
SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16))))

#INCLUDE include.h

IF VERSION(5) < 800
	? ERR_VFP_VERSION
	RETURN .F.
ENDIF

PRIVATE poBridge  && as DotNetBridge OF  ..\..\CommonTools\DotNetBridge.prg && FULLPATH(PATH_COMMON_TOOLS + "DotNetBridge.prg")
LOCAL loException as Exception;
	,lbError as Boolean;
	,lbResult as Boolean 
TRY
    *///////////////////////////////////////////////////////////////////////
    *// Check existence of external files
	IF !DIRECTORY(PATH_COMMON_TOOLS)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_COMMON_TOOLS)))
	ENDIF
	IF !DIRECTORY(PATH_XML)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_XML)))
	ENDIF
	IF !DIRECTORY(PATH_DOCX)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_DOCX)))
	ENDIF
	IF !DIRECTORY(PATH_XSLT)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_XSLT)))
	ENDIF
	LOCAL lcFileXslt as String
	lcFileXslt = LOWER(FULLPATH(PATH_XSLT)) + XSLT_FILE
	IF !FILE(lcFileXslt)
		ERROR 101, lcFileXslt
	ENDIF

    *///////////////////////////////////////////////////////////////////////
    *// Get docx-file from My Documents folder
	LOCAL loWSH as WScript.Shell
	loWSH =	CREATEOBJECT("WScript.Shell")
    LOCAL lcDocxFolder as String 
    lcDocxFolder = loWSH.SpecialFolders(MYDOC_FOLDER)
	LOCAL lcFileDocx as String 
	lcFileDocx = lcDocxFolder + "\_" + TEMPLATE_DOCX
	IF !FILE(lcFileDocx)
		ERROR 101, lcFileDocx
	ENDIF

	*////////////////////////////////////////////////////////////////
	*// Create DotNetBridge object
	LOCAL lcBridgeFileProc as String  
	lcBridgeFileProc = LOWER(FULLPATH(PATH_COMMON_TOOLS + BRIDGE_PROC))
	IF !FILE(lcBridgeFileProc)
		ERROR 101, lcBridgeFileProc
	ENDIF
	IF NOT (JUSTSTEM(lcBridgeFileProc) $ LOWER(SET("Procedure")))
		SET PROCEDURE TO (lcBridgeFileProc) ADDITIVE
	ENDIF	
	poBridge = CREATEOBJECT(BRIDGE_CLASS)
	IF VARTYPE(poBridge) # 'O'
		ERROR 'Can not create ' + BRIDGE_CLASS + ' object.'
	ENDIF

	*////////////////////////////////////////////////////////////////
	*// Set procedure to "FrameworkWrap.prg"
	LOCAL lcFrameworkWrapFileProc as String
	lcFrameworkWrapFileProc = LOWER(FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg"))
	IF !FILE(lcFrameworkWrapFileProc)
		ERROR 101, lcFrameworkWrapFileProc
	ENDIF
	IF NOT (JUSTSTEM(lcFrameworkWrapFileProc) $ LOWER(SET("Procedure"))) 
		SET PROCEDURE TO (lcFrameworkWrapFileProc) ADDITIVE
	ENDIF

	*////////////////////////////////////////////////////////////////
	*// LoadAssembly ASSEMBLY_SYSTEM
	IF !poBridge.LoadAssembly(ASSEMBLY_SYSTEM)
		ERROR poBridge.cErrorMsg
	ENDIF

	*//////////////////////////////////////////////////////////////////////////////
	*// Creation some objects from ASSEMBLY_SYSTEM, necessary during processing
	LOCAL loEnc as Encoding OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loEnc = CREATEOBJECT("Encoding", USE_ENCODING)
	LOCAL lnUriKindRelative as Integer 
	lnUriKindRelative = poBridge.GetStaticProperty("System.UriKind", "Relative")
	IF EMPTY(lnUriKindRelative)
		ERROR poBridge.cErrorMsg
	ENDIF
	LOCAL loUriWordSettingsXml as Uri OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loUriWordSettingsXml = CREATEOBJECT("Uri", URI_SETTINGS_XML, lnUriKindRelative)
	LOCAL loUriWordDocumentXml as Uri OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loUriWordDocumentXml = CREATEOBJECT("Uri", URI_DOCUMENT_XML, lnUriKindRelative)
	LOCAL lnFileModeOpen as Integer 
	lnFileModeOpen = poBridge.GetStaticProperty("System.IO.FileMode", "Open")
	IF EMPTY(lnFileModeOpen)
		ERROR poBridge.cErrorMsg
	ENDIF
	LOCAL lnFileAccessRead as Integer 
	lnFileAccessRead = poBridge.GetStaticProperty("System.IO.FileAccess", "Read")
	IF EMPTY(lnFileAccessRead)
		ERROR poBridge.cErrorMsg
	ENDIF
	LOCAL loMstrXmlDoc as MemoryStream OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loMstrXmlDoc = CREATEOBJECT("MemoryStream")
	
	*////////////////////////////////////////////////////////////////
	*// LoadAssembly ASSEMBLY_WINDOWSBASE
	IF !poBridge.LoadAssembly(ASSEMBLY_WINDOWSBASE)
		ERROR (loBridge.cErrorMsg)
	ENDIF

	*///////////////////////////////////////////////////////////////////////
	*// Get package of FileDocx and prepare for its processing
	LOCAL loPackage as Package OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPackage = CREATEOBJECT("Package", lcFileDocx)
	*-- Get PackagePart of FileDocx for URI_SETTINGS_XML(/word/settings.xml)
	LOCAL loPackagePartSettings as PackagePart OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPackagePartSettings = CREATEOBJECT("PackagePart";
		,loPackage.GetPart(loUriWordSettingsXml.GetOwnerFwObject()))
	*-- ... and its stream in Read mode
	LOCAL loPpStrmSettingsXml as Stream OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPpStrmSettingsXml = CREATEOBJECT("Stream";
		,loPackagePartSettings.GetStream(lnFileModeOpen, lnFileAccessRead))
	*-- Get PackagePart of FileDocx for URI_DOCUMENT_XML(/word/document.xml)
	LOCAL loPackagePartDocument as PackagePart OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPackagePartDocument = CREATEOBJECT("PackagePart";
		,loPackage.GetPart(loUriWordDocumentXml.GetOwnerFwObject()))
	*-- ... and its stream in Read mode
	LOCAL loPpStrmDocumentXml as Stream OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPpStrmDocumentXml = CREATEOBJECT("Stream";
		,loPackagePartDocument.GetStream(lnFileModeOpen, lnFileAccessRead))

	*////////////////////////////////////////////////////////////////
	*// LoadAssembly ASSEMBLY_SYSTEM_XML
	IF !poBridge.LoadAssembly(ASSEMBLY_SYSTEM_XML)
		ERROR poBridge.cErrorMsg
	ENDIF
	
	*///////////////////////////////////////////////////////////////////////
	*// Load stream SettingsXml as xml document
	LOCAL loXmlDocSettings as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocSettings = CREATEOBJECT("XmlDocument")
	loXmlDocSettings.Load(loPpStrmSettingsXml.GetOwnerFwObject())
	LOCAL loXmlDocSettingsRoot as XmlElement OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocSettingsRoot = CREATEOBJECT("XmlElement", loXmlDocSettings.DocumentElement)
	LOCAL lcNsp_w as String
	lcNsp_w = loXmlDocSettingsRoot.GetNamespaceOfPrefix("w")  
	LOCAL loNsMngr as XmlNamespaceManager OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loNsMngr = CREATEOBJECT("XmlNamespaceManager", loXmlDocSettings.NameTable)
	loNsMngr.AddNamespace("w", lcNsp_w)

	*///////////////////////////////////////////////////////////////////////
	*// Get AttachedSchema name
	LOCAL loXnAttachedSchema as XmlNode OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXnAttachedSchema = CREATEOBJECT("XmlNode";
		,loXmlDocSettingsRoot.SelectSingleNode("w:attachedSchema/@w:val", loNsMngr.getOwnerFwObject()))
	LOCAL lcDocxAttachedSchema as String
	lcDocxAttachedSchema = loXnAttachedSchema.Value

	*///////////////////////////////////////////////////////////////////////////////
	*// Get Location for XSD-schema from Microsoft Schema Library in system registry
	LOCAL lcPathSchemaLocation as String 
	LOCAL loRkCurrentUser as RegistryKey OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loRkCurrentUser = CREATEOBJECT("RegistryKey";
		,poBridge.GetStaticProperty("Microsoft.Win32.Registry", "CurrentUser"))
	LOCAL loRkSchemaLibrary as RegistryKey OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loRkSchemaLibrary = CREATEOBJECT("RegistryKey", loRkCurrentUser.OpenSubKey(KEY_SCHEMA_LIBRARY))
	LOCAL loRkDocxAttachedSchema as RegistryKey OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loRkDocxAttachedSchema = CREATEOBJECT("RegistryKey", loRkSchemaLibrary.OpenSubKey(lcDocxAttachedSchema + "\0"))
	lcPathSchemaLocation = loRkDocxAttachedSchema.GetValue(LOCATION_NAME_VALUE)

	*///////////////////////////////////////////////////////////////////////////////
	*// Load xsd-schema and get its root element
	LOCAL loXmlDocXsd as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocXsd = CREATEOBJECT("XmlDocument")
	loXmlDocXsd.Load(lcPathSchemaLocation)
	LOCAL loXmlDocXsdDocumentElement as XmlElement OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocXsdDocumentElement = CREATEOBJECT("XmlElement", loXmlDocXsd.DocumentElement)
	
	*///////////////////////////////////////////////////////////////////////////////
	*// Prepare and execute the xslt-transformation 
	*// with document.xml and by using xslt-file genXmlFromDocument.xslt
	LOCAL lcStrXmlDoc as String 
	LOCAL loXmlDoc as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDoc = CREATEOBJECT("XmlDocument")
	loXmlDoc.Load(loPpStrmDocumentXml.GetOwnerFwObject())
	LOCAL loXsltArgumentList as XsltArgumentList OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXsltArgumentList = CREATEOBJECT("XsltArgumentList")
	loXsltArgumentList.AddParam("prmEncoding", "", USE_ENCODING)
	IF !EMPTY(lcDocxAttachedSchema)
		loXsltArgumentList.AddParam("prmSchemaUri", "", lcDocxAttachedSchema)
	ENDIF
	IF VARTYPE(loXmlDocXsdDocumentElement) = 'O'
		loXsltArgumentList.AddParam("prmDocXsd", "", loXmlDocXsdDocumentElement.CreateNavigator())
	ENDIF
	LOCAL loXtwXmlDoc as XmlTextWriter OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXtwXmlDoc = CREATEOBJECT("XmlTextWriter";
		,loMstrXmlDoc.GetOwnerFwObject(), loEnc.GetOwnerFwObject())
	LOCAL loXslXmlDocTrans as XslCompiledTransform OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXslXmlDocTrans = CREATEOBJECT("XslCompiledTransform")
	loXslXmlDocTrans.Load(lcFileXslt)
	loXslXmlDocTrans.Transform(loXmlDoc.CreateNavigator();
		,loXsltArgumentList.GetOwnerFwObject(), loXtwXmlDoc.GetOwnerFwObject())
	lcStrXmlDoc = loEnc.GetString(loMstrXmlDoc.GetBuffer(), 0, loMstrXmlDoc.Length)
	LOCAL lnPos as Integer
	lnPos = ATC("<", lcStrXmlDoc)
	IF lnPos = 0
		ERROR (ERR_EMPTY_XSLTRES + lcFileGenXsltFromTemplate)
	ENDIF
	lcStrXmlDoc = SUBSTRC(lcStrXmlDoc, lnPos)
	lnPos = ATC("<?xml", lcStrXmlDoc)
	IF lnPos = 0
		lcStrXmlDoc = XML_PI + lcStrXmlDoc
	ENDIF

	*///////////////////////////////////////////////////////////////////////////////
	*// Load & save result of xslt-transformation
	LOCAL loXmlDocXml as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	LOCAL lcOutputFileXml as String
	lcOutputFileXml = LOWER(FULLPATH(PATH_XML)) + XML_OUTPUT_FILE
	loXmlDocXml = CREATEOBJECT("XmlDocument")
	loXmlDocXml.LoadXml(lcStrXmlDoc)
	loXmlDocXml.Save(lcOutputFileXml)
	lbResult = .T.
CATCH TO loException
	lbError = .T.
	LOCAL lcMsg as String
	lcMsg = ERR_CODE + LTRIM(STR(loException.ErrorNo)) + CRLF ;
		+ ERR_LINE + LTRIM(STR(loException.LineNo)) + CRLF ;
		+ ERR_MESSAGE + IIF(EMPTY(loException.Message), 'Unknown error', loException.Message)
	? ERR_LABEL_OUTPUT
	? lcMsg
FINALLY
	loWSH = NULL
	IF TYPE('poBridge') = 'O' AND !ISNULL(poBridge)
		*-- Remove all objects, which keeping resources of memory 
		loRkDocxAttachedSchema = NULL
		loRkSchemaLibrary = NULL
		loRkCurrentUser = NULL
		loPpStrmSettingsXml = NULL
		loPpStrmDocumentXml = NULL
		loMstrXmlDoc = NULL
		loXtwXmlDoc = NULL
		loPackage = NULL
		poBridge.Unload()
		poBridge = NULL
	ENDIF
	IF lbError
		? ERR_TERMINATED
	ENDIF
	IF lbResult AND FILE(lcOutputFileXml)
		? MSG_SUCCESS_RESUT
		? MSG_FILE_CREATED1 + lcOutputFileXml + CHR(32) + MSG_FILE_CREATED2
	ENDIF
ENDTRY
RETURN lbResult