CLEAR
SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16))))

#INCLUDE include.h

IF VERSION(5) < 800
	? ERR_VFP_VERSION
	RETURN .F.
ENDIF

PRIVATE poBridge && as DotNetBridge OF  ..\..\CommonTools\DotNetBridge.prg && FULLPATH(PATH_COMMON_TOOLS + "DotNetBridge.prg")
LOCAL loException as Exception;
	,lbError as Boolean;
	,lbResult as Boolean 
TRY
    *///////////////////////////////////////////////////////////////////////
    *// Check existence of external files
	IF !DIRECTORY(PATH_COMMON_TOOLS)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_COMMON_TOOLS)))
	ENDIF
	IF !DIRECTORY(PATH_XML)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_XML)))
	ENDIF
	IF !DIRECTORY(PATH_DOCX)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_DOCX)))
	ENDIF
	IF !DIRECTORY(PATH_XSLT)
		ERROR (ERR_DIR_NOTFOUND + LOWER(FULLPATH(PATH_XSLT)))
	ENDIF
	LOCAL lcFileXmlData as String 
	lcFileXmlData = LOWER(FULLPATH(PATH_XML + XML_DATA_FILE))
	IF !FILE(lcFileXmlData)
		ERROR 101, lcFileXmlData
	ENDIF
	LOCAL lcFileTemplateDocx as String 
	lcFileTemplateDocx = LOWER(FULLPATH(PATH_DOCX)) + TEMPLATE_DOCX
	IF !FILE(lcFileTemplateDocx)
		ERROR 101, lcFileTemplateDocx
	ENDIF
	LOCAL lcFileGenXsltFromTemplate as String 
	lcFileGenXsltFromTemplate = LOWER(FULLPATH(PATH_XSLT)) + XSLT_FILE
	IF !FILE(lcFileTemplateDocx)
		ERROR 101, lcFileGenXsltFromTemplate
	ENDIF

	*////////////////////////////////////////////////////////////////
	*// Create DotNetBridge object
	LOCAL lcBridgeFileProc as String  
	lcBridgeFileProc = LOWER(FULLPATH(PATH_COMMON_TOOLS + BRIDGE_PROC))
	IF !FILE(lcBridgeFileProc)
		ERROR 101, lcBridgeFileProc
	ENDIF
	IF NOT (JUSTSTEM(lcBridgeFileProc) $ LOWER(SET("Procedure")))
		SET PROCEDURE TO (lcBridgeFileProc) ADDITIVE
	ENDIF	
	poBridge = CREATEOBJECT(BRIDGE_CLASS)
	IF VARTYPE(poBridge) # 'O'
		ERROR 'Can not create ' + BRIDGE_CLASS + ' object.'
	ENDIF

	*////////////////////////////////////////////////////////////////
	*// Set procedure to "FrameworkWrap.prg"
	LOCAL lcFrameworkWrapFileProc as String
	lcFrameworkWrapFileProc = LOWER(FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg"))
	IF !FILE(lcFrameworkWrapFileProc)
		ERROR 101, lcFrameworkWrapFileProc
	ENDIF
	IF NOT (JUSTSTEM(lcFrameworkWrapFileProc) $ LOWER(SET("Procedure"))) 
		SET PROCEDURE TO (lcFrameworkWrapFileProc) ADDITIVE
	ENDIF

	*////////////////////////////////////////////////////////////////
	*// LoadAssembly ASSEMBLY_SYSTEM
	IF !poBridge.LoadAssembly(ASSEMBLY_SYSTEM)
		ERROR poBridge.cErrorMsg
	ENDIF
	
    *///////////////////////////////////////////////////////////////////////
    *// Copy template to target folder
	LOCAL loWSH as WScript.Shell
	loWSH =	CREATEOBJECT("WScript.Shell")
    LOCAL lcOutputFolder as String 
    lcOutputFolder = loWSH.SpecialFolders(MYDOC_FOLDER)
	LOCAL lcOutputFileDocx as String 
	lcOutputFileDocx = lcOutputFolder + "\_" + TEMPLATE_DOCX
	poBridge.InvokeStaticMethod("System.IO.File", "Copy", lcFileTemplateDocx, lcOutputFileDocx, .T.)
	IF !EMPTY(poBridge.cErrorMsg)
		ERROR poBridge.cErrorMsg
	ENDIF

	*//////////////////////////////////////////////////////////////////////////////
	*// Creation some objects from ASSEMBLY_SYSTEM, necessary during processing
	LOCAL loEnc as Encoding OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loEnc = CREATEOBJECT("Encoding", USE_ENCODING)
	LOCAL lnUriKindRelative as Integer 
	lnUriKindRelative = poBridge.GetStaticProperty("System.UriKind", "Relative")
	IF EMPTY(lnUriKindRelative)
		ERROR poBridge.cErrorMsg
	ENDIF
	LOCAL loUri as Uri OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loUri = CREATEOBJECT("Uri", URI_DOCUMENT_XML, lnUriKindRelative)
	LOCAL lnFileModeOpen as Integer 
	lnFileModeOpen = poBridge.GetStaticProperty("System.IO.FileMode", "Open")
	IF EMPTY(lnFileModeOpen)
		ERROR poBridge.cErrorMsg
	ENDIF
	LOCAL lnFileAccessReadWrite as Integer 
	lnFileAccessReadWrite = poBridge.GetStaticProperty("System.IO.FileAccess", "ReadWrite")
	IF EMPTY(lnFileAccessReadWrite)
		ERROR poBridge.cErrorMsg
	ENDIF
	LOCAL loMstrXsltDoc as MemoryStream OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loMstrXsltDoc = CREATEOBJECT("MemoryStream")
	LOCAL loMstrXmlDoc as MemoryStream OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loMstrXmlDoc = CREATEOBJECT("MemoryStream")
	
	*////////////////////////////////////////////////////////////////
	*// LoadAssembly ASSEMBLY_WINDOWSBASE
	IF !poBridge.LoadAssembly(ASSEMBLY_WINDOWSBASE)
		ERROR (loBridge.cErrorMsg)
	ENDIF

	*///////////////////////////////////////////////////////////////////////
	*// Get package copy of template and prepare for its processing
	LOCAL loPackage as Package OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPackage = CREATEOBJECT("Package", lcOutputFileDocx)
	*-- Get PackagePart of template for URI_DOCUMENT_XML(/word/document.xml)
	LOCAL loPackagePart as PackagePart OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPackagePart = CREATEOBJECT("PackagePart";
		,loPackage.GetPart(loUri.GetOwnerFwObject()))
	*-- ... and its stream in ReadWrite mode
	LOCAL loPpStrmXmlDoc as Stream OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loPpStrmXmlDoc = CREATEOBJECT("Stream";
		,loPackagePart.GetStream(lnFileModeOpen, lnFileAccessReadWrite))

	*////////////////////////////////////////////////////////////////
	*// LoadAssembly ASSEMBLY_SYSTEM_XML
	IF !poBridge.LoadAssembly(ASSEMBLY_SYSTEM_XML)
		ERROR poBridge.cErrorMsg
	ENDIF
	
	*///////////////////////////////////////////////////////////////////////
	*// Load xml-data file and get name of its root element
	LOCAL loXmlDocData as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocData = CREATEOBJECT("XmlDocument")
	loXmlDocData.Load(lcFileXmlData)
	LOCAL loXmlDocDataDocumentElement as XmlElement OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocDataDocumentElement = CREATEOBJECT("XmlElement", loXmlDocData.DocumentElement)
	LOCAL lcRootElementName as String 
	lcRootElementName = loXmlDocDataDocumentElement.ElementName
	
	*///////////////////////////////////////////////////////////////////////////////
	*// Prepare and execute the first xslt-transformation 
	*// with document.xml and by using xslt-file FileGenXsltFromTemplate
	LOCAL lcStrXsltDoc as String 
	LOCAL loXmlDoc as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDoc = CREATEOBJECT("XmlDocument")
	loXmlDoc.Load(loPpStrmXmlDoc.GetOwnerFwObject())
	LOCAL loXsltArgumentList as XsltArgumentList OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXsltArgumentList = CREATEOBJECT("XsltArgumentList")
	loXsltArgumentList.AddParam("prmRootElement", "", lcRootElementName)
	loXsltArgumentList.AddParam("prmEncoding", "", USE_ENCODING)
	LOCAL loXtwXsltDoc as XmlTextWriter OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXtwXsltDoc = CREATEOBJECT("XmlTextWriter";
		,loMstrXsltDoc.GetOwnerFwObject(), loEnc.GetOwnerFwObject())
	LOCAL loXslXsltDocTrans as XslCompiledTransform OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXslXsltDocTrans = CREATEOBJECT("XslCompiledTransform")
	loXslXsltDocTrans.Load(lcFileGenXsltFromTemplate)
	loXslXsltDocTrans.Transform(loXmlDoc.CreateNavigator();
		,loXsltArgumentList.GetOwnerFwObject(), loXtwXsltDoc.GetOwnerFwObject())
	lcStrXsltDoc = loEnc.GetString(loMstrXsltDoc.GetBuffer(), 0, loMstrXsltDoc.Length)
	LOCAL lnPos as Integer
	lnPos = ATC("<", lcStrXsltDoc)
	IF lnPos = 0
		ERROR (ERR_EMPTY_XSLTRES + lcFileGenXsltFromTemplate)
	ENDIF
	lcStrXsltDoc = SUBSTRC(lcStrXsltDoc, lnPos)
	lnPos = ATC("<?xml", lcStrXsltDoc)
	IF lnPos = 0
		lcStrXsltDoc = XML_PI + lcStrXsltDoc
	ENDIF

	*///////////////////////////////////////////////////////////////////////////////
	*// Load result of first xslt-transformation
	LOCAL loXmlDocXslt as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocXslt = CREATEOBJECT("XmlDocument")
	loXmlDocXslt.LoadXml(lcStrXsltDoc)
#IF TMP_OUT	
	loXmlDocXslt.Save(XSLT_FILE_FIRST_RESULT)
#ENDIF

	*///////////////////////////////////////////////////////////////////////////////
	*// Prepare and execute the second xslt-transformation 
	*// with input xml-data-file and by using first result of xslt-transformation
	LOCAL lcStrXmlDoc as String 
	LOCAL loXslXmlDocTrans as XslCompiledTransform OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXslXmlDocTrans = CREATEOBJECT("XslCompiledTransform")
	loXslXmlDocTrans.Load(loXmlDocXslt.CreateNavigator())
	LOCAL loXtwXmlDoc as XmlTextWriter OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXtwXmlDoc = CREATEOBJECT("XmlTextWriter";
		,loMstrXmlDoc.GetOwnerFwObject(), loEnc.GetOwnerFwObject())
	loXslXmlDocTrans.Transform(loXmlDocData.CreateNavigator(), loXtwXmlDoc.GetOwnerFwObject())
	lcStrXmlDoc = loEnc.GetString(loMstrXmlDoc.GetBuffer(), 0, loMstrXmlDoc.Length)
	lnPos = ATC("<", lcStrXmlDoc)
	IF lnPos = 0
		ERROR (ERR_EMPTY_XSLTRES + lcFileXmlData)
	ENDIF
	lcStrXmlDoc = SUBSTRC(lcStrXmlDoc, lnPos)
	lnPos = ATC("<?xml", lcStrXmlDoc)
	IF lnPos = 0
		lcStrXmlDoc = XML_PI + lcStrXmlDoc
	ENDIF
	
	*///////////////////////////////////////////////////////////////////////////////
	*// Load result of second xslt-transformation as xml-document
	LOCAL loXmlDocOut as XmlDocument OF ..\..\CommonTools\FrameworkWrap.prg && FULLPATH(PATH_COMMON_TOOLS + "FrameworkWrap.prg")
	loXmlDocOut = CREATEOBJECT("XmlDocument")
	loXmlDocOut.LoadXml(lcStrXmlDoc)
#IF TMP_OUT
	loXmlDocOut.Save(XML_FILE_SECOND_RESULT)
#ENDIF
	*///////////////////////////////////////////////////////////////////////////////
	*// Replace PackagePart-stream with result of second xslt-transformation
	loPpStrmXmlDoc.Position = 0
	loXmlDocOut.Save(loPpStrmXmlDoc.GetOwnerFwObject())
	loPpStrmXmlDoc.Flush()

	*///////////////////////////////////////////////////////////////////////////////
	*// Close stream and package
	loPpStrmXmlDoc.Close()
	loPpStrmXmlDoc = NULL
	IF !ISNULL(loPackage)
		loPackage.Flush()
		loPackage.Close()
		loPackage = NULL
	ENDIF

	*///////////////////////////////////////////////////////////////////////////////
	*// Open the new docx file in Word 2007
	WAIT MSG_SUCCESS_RESUT WINDOW NOWAIT TIMEOUT 10
	DECLARE INTEGER ShellExecute IN shell32.dll ;
		INTEGER hwnd, ;
		STRING @lsOperation, ;
		STRING @lsFile, ;
		STRING @lsParameters, ;
		STRING @lsDirectory, ;
		INTEGER liShowCmd
	DECLARE INTEGER GetDesktopWindow IN user32.dll
	LOCAL lnRetCode as Integer 
	lnRetCode = 0
	lnRetCode = ShellExecute(GetDesktopWindow(), "open", lcOutputFileDocx, "", "", SW_NORMAL)
	CLEAR DLLS 
	IF lnRetCode > 32
		lbResult = .T.
	ELSE
		ERROR "ShellExecute: errorcode = " + LTRIM(STR(lnRetCode))
	ENDIF
CATCH TO loException
	lbError = .T.
	LOCAL lcMsg as String
	lcMsg = ERR_CODE + LTRIM(STR(loException.ErrorNo)) + CRLF ;
		+ ERR_LINE + LTRIM(STR(loException.LineNo)) + CRLF ;
		+ ERR_MESSAGE + IIF(EMPTY(loException.Message), 'Unknown error', loException.Message)
	? ERR_LABEL_OUTPUT
	? lcMsg
FINALLY
	loWSH = NULL
	IF TYPE('poBridge') = 'O' AND !ISNULL(poBridge)
		*-- Remove all objects, which keeping resources of memory 
		loXtwXmlDoc = NULL
		loXtwXsltDoc = NULL
		loPpStrmXmlDoc = NULL
		loMstrXsltDoc = NULL
		loMstrXmlDoc = NULL
		loPackage = NULL
		poBridge.Unload()
		poBridge = NULL
	ENDIF
ENDTRY
RETURN lbResult