<?xml version="1.0" encoding="utf-8"?>
<!-- file: genXsltFromTemplate.xslt -->
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:msdata="urn:schemas-microsoft-com:xml-msdata"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  exclude-result-prefixes="xsi msxsl msdata">

  <xsl:output version="1.0" method="xml"
    encoding="utf-8" omit-xml-declaration="yes" />

  <!-- Root element in xml-data -->
  <xsl:param name="prmRootElement">
    <xsl:text>VFPData</xsl:text>
  </xsl:param>

  <!-- Current encoding to replace in output xml-PI -->
  <xsl:param name="prmEncoding">
    <xsl:text>utf-8</xsl:text>
  </xsl:param>

  <xsl:template match="/">
    <xsl:text disable-output-escaping="yes"><![CDATA[<?xml version="1.0" encoding="]]></xsl:text>
    <xsl:value-of select="$prmEncoding" />
    <xsl:text disable-output-escaping="yes"><![CDATA[" standalone="yes"?>]]>&#xD;&#xA;</xsl:text>
    <!-- Generate open <xsl:stylesheet... & <xsl:template... elements into output -->
    <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:stylesheet version="1.0"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:xsl="http://www.w3.org/1999/XSL/Transform"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:msxsl="urn:schemas-microsoft-com:xslt"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:msdata="urn:schemas-microsoft-com:xml-msdata"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:o="urn:schemas-microsoft-com:office:office"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:v="urn:schemas-microsoft-com:vml"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:w10="urn:schemas-microsoft-com:office:word"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[ exclude-result-prefixes="xsi msxsl msdata">]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:output version="1.0" method="xml" encoding="]]></xsl:text>
    <xsl:value-of select="$prmEncoding" />
    <xsl:text disable-output-escaping="yes"><![CDATA[" standalone="yes" />]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:template match="/">]]></xsl:text>
    <!-- Open w:document element -->
    <w:document xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
		 xmlns:o="urn:schemas-microsoft-com:office:office"
		 xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
		 xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
		 xmlns:v="urn:schemas-microsoft-com:vml"
		 xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
		 xmlns:w10="urn:schemas-microsoft-com:office:word"
		 xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
		 xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml">
      <!-- ... continue parsing for childrens of w:document element ... -->
      <xsl:apply-templates select="/./w:document/*" />
      <!-- Close w:document element -->
    </w:document>
    <!-- Generate close ... </xsl:template> & ...</xsl:stylesheet> elements into output -->
    <xsl:text disable-output-escaping="yes"><![CDATA[</xsl:template>]]></xsl:text>
    <xsl:text disable-output-escaping="yes"><![CDATA[</xsl:stylesheet>]]></xsl:text>
  </xsl:template>

  <!-- Parsing any current input... -->
  <xsl:template match="@*|node()">
    <!-- Get current name from input -->
    <xsl:variable name="varName">
      <xsl:value-of select="name()" />
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="string-length($varName)>0">
        <xsl:choose>
          <xsl:when test="$varName='w:customXml'">
            <!-- Parsing <w:customXml...>...</w:customXml> -->
            <xsl:call-template name="genCustomXml">
              <xsl:with-param name="prmElementName" select="@w:element" />
              <xsl:with-param name="prmChildren" select="*" />
            </xsl:call-template>
          </xsl:when>
          <xsl:otherwise>
            <!-- Parsing any other... -->
            <!-- ... copy current element into output-->
            <xsl:element name="{$varName}">
              <xsl:for-each select="@*">
                <xsl:attribute name="{name()}">
                  <xsl:value-of select="." />
                </xsl:attribute>
              </xsl:for-each>
              <!-- ... continue parsing for child & as child ... -->
              <xsl:apply-templates select="child::*" />
              <xsl:value-of select="text()" />
            </xsl:element>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates select="@*|node()" />\
			</xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- Generate w:customXml element -->
  <xsl:template name="genCustomXml">
    <xsl:param name="prmElementName"/>
    <xsl:param name="prmChildren"/>
    <!-- Get current name of element from input -->
    <xsl:variable name="varName">
      <xsl:value-of select="name()" />
    </xsl:variable>
    <xsl:choose>
      <xsl:when test="$prmElementName=$prmRootElement">
        <!-- Case w:customXml element is root -->
        <!-- ... copy current element (w:customXml) -->
        <xsl:element name="{$varName}">
          <xsl:for-each select="@*">
            <xsl:attribute name="{name()}">
              <xsl:value-of select="." />
            </xsl:attribute>
          </xsl:for-each>
          <!-- Continue parsing for child... -->
          <xsl:apply-templates select="msxsl:node-set($prmChildren)/." />
        </xsl:element>
      </xsl:when>
      <xsl:when test="count(msxsl:node-set($prmChildren)/.)=0">
        <!-- Case w:customXml element with empty childrens -->
        <!-- ... copy current element (w:customXml) -->
        <xsl:element name="{$varName}">
          <xsl:for-each select="@*">
            <xsl:attribute name="{name()}">
              <xsl:value-of select="." />
            </xsl:attribute>
          </xsl:for-each>
          <!-- Generate <w:r>...</w:r> as child -->
          <xsl:call-template name="genRunElement">
            <xsl:with-param name="prmElementName" select="$prmElementName" />
          </xsl:call-template>
        </xsl:element>
      </xsl:when>
      <xsl:when test="name(msxsl:node-set($prmChildren)/.)='w:tc'">
        <!-- Case w:customXml element with <w:tc>...</w:tc> as first child -->
        <!-- ... copy current element (w:customXml) -->
        <xsl:element name="{$varName}">
          <xsl:for-each select="@*">
            <xsl:attribute name="{name()}">
              <xsl:value-of select="." />
            </xsl:attribute>
          </xsl:for-each>
          <!-- Generate <w:tc>...</w:tc> as child -->
          <w:tc>
            <!-- Scan all children elements in current <w:tc>...</w:tc> in input -->
            <xsl:for-each select="msxsl:node-set($prmChildren)/./*">
              <xsl:choose>
                <!-- ... in case <w:p>...</w:p> -->
                <xsl:when test="name()='w:p'">
                  <!-- Copy current element (w:p) -->
                  <xsl:element name="{name()}">
                    <xsl:for-each select="@*">
                      <xsl:attribute name="{name()}">
                        <xsl:value-of select="." />
                      </xsl:attribute>
                    </xsl:for-each>
                    <!-- ... copy all current child contents as child -->
                    <!--<xsl:apply-templates select="child::*" /> -->
                    <xsl:copy-of select="child::*" />
                    <!-- ... insert <w:t>...</w:t> as child -->
                    <xsl:call-template name="genRunElement">
                      <xsl:with-param name="prmElementName" select="$prmElementName" />
                    </xsl:call-template>
                  </xsl:element>
                </xsl:when>
                <!-- ... for any other case... -->
                <xsl:otherwise>
                  <!-- Copy all current contents into output -->
                  <!--<xsl:apply-templates select="*" /> -->
                  <xsl:copy>
                    <xsl:copy-of select="*" />
                  </xsl:copy>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:for-each>
          </w:tc>
        </xsl:element>
      </xsl:when>
      <xsl:when test="name(msxsl:node-set($prmChildren)/.)='w:tr'">
        <!-- Case w:customXml element with <w:tr>...</w:tr> as first child -->
        <!-- ... generate <xsl:for-each ... -->
        <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:for-each select="//]]></xsl:text>
        <xsl:value-of select="$prmRootElement" />
        <xsl:text disable-output-escaping="yes"><![CDATA[/]]></xsl:text>
        <xsl:value-of select="$prmElementName" />
        <xsl:text disable-output-escaping="yes"><![CDATA[">]]></xsl:text>
        <!-- ... copy current element (w:customXml) -->
        <xsl:element name="{$varName}">
          <xsl:for-each select="@*">
            <xsl:attribute name="{name()}">
              <xsl:value-of select="." />
            </xsl:attribute>
          </xsl:for-each>
          <!-- Select current <w:tr>...</w:tr> in input -->
          <xsl:for-each select="msxsl:node-set($prmChildren)/.">
            <!-- Copy <w:tr>...</w:tr> into output -->
            <xsl:element name="{name()}">
              <xsl:for-each select="@*">
                <xsl:attribute name="{name()}">
                  <xsl:value-of select="." />
                </xsl:attribute>
              </xsl:for-each>
              <!-- Scan all children elements in current <w:tr>...</w:tr> in input -->
              <xsl:for-each select="msxsl:node-set($prmChildren)/./*">
                <xsl:choose>
                  <!-- ... in case not <w:customXml>...</w:customXml> -->
                  <xsl:when test="name()!='w:customXml'">
                    <!-- Copy all current contents into output -->
                    <xsl:copy-of select="." />
                  </xsl:when>
                  <!-- ... in case <w:customXml>...</w:customXml> -->
                  <xsl:otherwise>
                    <!-- Continue parsing ... -->
                    <xsl:apply-templates select="." />
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
            </xsl:element>
          </xsl:for-each>
        </xsl:element>
        <!-- ... close </xsl:for-each> -->
        <xsl:text disable-output-escaping="yes"><![CDATA[</xsl:for-each>]]></xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <!-- In any other case: insert your code here ...
				<xsl:text disable-output-escaping="yes"><![CDATA[<xsl:for-each select="//]]></xsl:text>
				<xsl:value-of select="$prmRootElement" />
				<xsl:text disable-output-escaping="yes"><![CDATA[/]]></xsl:text>
				<xsl:value-of select="$prmElementName" />
				<xsl:text disable-output-escaping="yes"><![CDATA[">]]></xsl:text>
				<xsl:apply-templates select="msxsl:node-set($prmChildren)/./*" />
				<xsl:text disable-output-escaping="yes"><![CDATA[</xsl:for-each>]]></xsl:text>
        -->
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- Generate <w:r>... <w:r> element -->
  <xsl:template name="genRunElement">
    <xsl:param name="prmElementName" />
    <w:r>
      <w:rPr>
        <!--<w:cnfStyle w:val="000000100000" />-->
        <xsl:choose>
          <xsl:when test="$prmElementName='birthdate'">
            <w:lang w:val="ru-RU" />
          </xsl:when>
          <xsl:otherwise>
            <w:lang w:val="en-US" />
          </xsl:otherwise>
        </xsl:choose>
      </w:rPr>
      <!-- Generate <w:t>... <w:t> element -->
      <xsl:call-template name="genTextContent">
        <xsl:with-param name="prmElementName" select="$prmElementName" />
      </xsl:call-template>
    </w:r>
  </xsl:template>

  <!-- Generate <w:t>... <w:t> element -->
  <xsl:template name="genTextContent">
    <xsl:param name="prmElementName" />
    <w:t>
      <!-- Generate output according to name of element -->
      <xsl:choose>
        <xsl:when test="$prmElementName='notes'">
          <!-- ... for long input string only first 50 chars of string -->
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:choose>]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:when test="string-length(notes)&lt;51">]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:value-of select="notes"/>]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[</xsl:when>]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:otherwise>]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:value-of select="concat(substring(notes,1,50), substring-before(substring(notes,51), ' '), ' ...')" />]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[</xsl:otherwise>]]></xsl:text>
          <xsl:text disable-output-escaping="yes"><![CDATA[</xsl:choose>]]></xsl:text>
        </xsl:when>
        <xsl:when test="$prmElementName='birthdate'">
          <!-- ... convert to russian date format -->
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:value-of select="msxsl:format-date(birthdate, 'dd.MM.yyyy')" />]]></xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <!-- ... simple copy -->
          <xsl:text disable-output-escaping="yes"><![CDATA[<xsl:value-of select="]]></xsl:text>
          <xsl:value-of select="$prmElementName"/>
          <xsl:text disable-output-escaping="yes"><![CDATA[" />]]></xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </w:t>
  </xsl:template>

</xsl:stylesheet> 
